package com.alipay.demo;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Random;

import com.alipay.api.AlipayApiException;
import com.alipay.api.AlipayClient;
import com.alipay.api.DefaultAlipayClient;
import com.alipay.api.domain.BudgetInfo;
import com.alipay.api.domain.ConstraintInfo;
import com.alipay.api.domain.ItemInfo;
import com.alipay.api.domain.KoubeiMarketingCampaignActivityCreateModel;
import com.alipay.api.domain.PromoTool;
import com.alipay.api.domain.PublishChannel;
import com.alipay.api.domain.SendRule;
import com.alipay.api.domain.UseRule;
import com.alipay.api.domain.Voucher;
import com.alipay.api.request.KoubeiMarketingCampaignActivityCreateRequest;
import com.alipay.api.response.KoubeiMarketingCampaignActivityCreateResponse;
import com.alipay.config.AlipayConfig;

/**
 * koubei.marketing.campaign.activity.create (ӿ)
 * @author wb-wly251833
 * ĵӣhttps://doc.open.alipay.com/doc2/apiDetail.htm?spm=a219a.7395905.0.0.zlCQSG&docType=4&apiId=1086
 */
public class koubeiMarketingCampaignActivityCreate {

	public static void main(String[] args) throws AlipayApiException, ParseException {
		AlipayClient alipayClient = new DefaultAlipayClient(AlipayConfig.gatewayUrl, AlipayConfig.app_id, AlipayConfig.merchant_private_key, AlipayConfig.format, AlipayConfig.charset, AlipayConfig.alipay_public_key, AlipayConfig.sign_type);
		KoubeiMarketingCampaignActivityCreateRequest request = new KoubeiMarketingCampaignActivityCreateRequest();
		KoubeiMarketingCampaignActivityCreateModel model = new KoubeiMarketingCampaignActivityCreateModel();

		//ⲿID
		model.setOutBizNo(getOutBizNo());   
		//
		model.setName("10Ԫ1Ԫȯ"); 
	    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");  
	    Date startTime = sdf.parse("2017-05-01 00:00:00");  
	    Date endTime = sdf.parse("2018-05-01 00:00:00");  
		//ʼʱ
		model.setStartTime(startTime); 
		//ʱ
		model.setEndTime(endTime); 
		//ͣCONSUME_SENDͻ; DIRECT_SENDֱ; REAL_TIME_SENDʵʱ 
		model.setType("REAL_TIME_SEND"); 
		//ϸ˵
		model.setDesc("ûʧû"); 
		//Ͷ
		model.setPublishChannels(getPublishChannels());
		//Ԥ
		model.setBudgetInfo(getBudgetInfo());
		// Ϣ
		model.setConstraintInfo(getConstraintInfo());
		
		/********Ӫ߼   **********/
		List<PromoTool> toolList =new ArrayList<>();
		toolList.add(getPromoTool());
		model.setPromoTools(toolList); 
		
		request.setBizModel(model);
		KoubeiMarketingCampaignActivityCreateResponse response = alipayClient.execute(request);
		if(response.isSuccess()){
		System.out.println("óɹ");
		} else {
		System.out.println("ʧ");
		}
		 System.out.println(response.getBody());
	}
	
	
	/**
	 * ⲿID
	 * @return
	 */
	private static String getOutBizNo() {
	    SimpleDateFormat simpleDateFormat;
	    simpleDateFormat = new SimpleDateFormat("yyyyMMdd");
	    Date date = new Date();
	    String str = simpleDateFormat.format(date);
	    Random random = new Random();
	    int rannum = (int) (random.nextDouble() * (999 - 100 + 1)) + 100;// ȡ5λ
	    return str+rannum;// ǰʱ
	}
	
	/**
	 * Ͷ
	 * @return
	 */
	private static List<PublishChannel> getPublishChannels() {
	  // TODO Auto-generated method stub
	  List<PublishChannel> l=new ArrayList<>();
	  PublishChannel p= new PublishChannel();
	  p.setType("SHOP_DETAIL");
	  p.setName("Ͷŵ");
	  l.add(p);
	  return l;
	}
	
	
	/**
	 * Ϣ
	 * @return
	 */
	private static ConstraintInfo getConstraintInfo() {
		ConstraintInfo constraintInfo = new  ConstraintInfo();
		//ڼûܹĴ ,
		constraintInfo.setUserWinCount("1"); 
		//ڼûܹƵ ,ƲƵʣ ÿн1: D||1  
		constraintInfo.setUserWinFrequency("D||3"); 
		//ȺID ȺID ֱͻЧͨӪȺ򴴽ӿڲ
//		constraintInfo.setCrowdGroupId("12344556"); 
		//ָȺԼ
		constraintInfo.setCrowdRestriction("NEW_MEMBER_PROMO");
		//õŵбƷ̷̻Ϊ ֧10wŵ
		constraintInfo.setSuitShops(getSuitShops());
		//ѽλԪ ڴʱ
		constraintInfo.setMinCost("20");
		return constraintInfo;
	    }
	
	/**
	 * ȯ󣬵ΪPOINT_SENDʱΪnullʹֶα
	 * @return
	 */
	private static  Voucher getVoucher(){
		Voucher voucher = new Voucher();
		//ȯͣĿǰ֧ͣ  EXCHANGEһȯ;  MONEYȯ;  REDUCETOȯ;  RATEۿȯ
		voucher.setType("MONEY");
		//ֶνڶһȯ(ȯΪEXCHANGE)öһȯĺʽ 
		//voucher.setVerifyMode("MERCHANT_SCAN");
		//
		voucher.setName("ʮһ");
		
		//ȯʹ˵ 
		List<String> UseInstructionsList = new ArrayList<>();
		UseInstructionsList.add("ʮһؼŻ");
		voucher.setUseInstructions(UseInstructionsList);
//		voucher.setStartTime();
//		voucher.getEndTime()
		//ȯLOGOļIDͼƬϴӿalipay.offline.material.image.upload
		voucher.setLogo("gKpPK40RSNeBiMxDsat8CQAAACMAAQED");
		//ȯЧͣĿǰ֧ͣ RELATIVEЧ ,FIXEDЧ
		voucher.setValidateType("RELATIVE");
		//ȯ
		voucher.setBrandName("ȯ");
		//ȯЧķʽĿǰ֧·ʽ ЧIMMEDIATELY;  ӳЧDELAY ȯЧΪЧʱЧ
		voucher.setEffectType("IMMEDIATELY");
		//ȯ
		voucher.setWorthValue("1");
		// ȯʹùϢ
		voucher.setUseRule(getUseRule());
		//ƷϢ һȯõƷϢ ȯõƷϢ ȯɰ
		voucher.setItemInfo(getItemInfo());
		//ȯıע
		voucher.setVoucherNote("ȯıע");
		return voucher;
	}
	
	/**
	 * Item_Info ƷϢ
	 * @return
	 */
	private static ItemInfo getItemInfo() {
		  // TODO Auto-generated method stub
		  ItemInfo itemInfo=new ItemInfo();
		  itemInfo.setItemText("Ʒ");
		  itemInfo.setItemName("ԵƷŻ");
		  itemInfo.setItemIds(getitemIds());
		  return itemInfo;
	}
	
	/**
	 * item_ids Ʒб 
	 * @return
	 */
	private static List<String> getitemIds() {
		  // TODO Auto-generated method stub
		  List<String> l=new ArrayList<>();
		  l.add("000123456");
		  return l;
	}
	
	/**
	 * ȯʹùϢ
	 * @return
	 */
	private static UseRule getUseRule(){
		UseRule useRule = new UseRule();
		useRule.setSuitShops(getSuitShops());
		return useRule;
	}
	
	/**
	 * õŵб 
	 * @return
	 */
	private static List<String> getSuitShops() {
		  // TODO Auto-generated method stub
		  List<String> SuitShops=new ArrayList<>();
		  SuitShops.add("2017090500077000000000123588");
		  SuitShops.add("2017031700077000000000073266");
		  return SuitShops;
	}
	
	/**
	 * Ӫ߼
	 * @return
	 */
	private static  PromoTool getPromoTool(){
		PromoTool promoTool = new PromoTool();
		//ȯ
		promoTool.setVoucher(getVoucher());
		//ӪߵЧ״̬̲ȯʧЧʹֶ
		//promoTool.setStatus("");
		//ƷŵĹ
		promoTool.setSendRule(getSendRule());
		return  promoTool;
	}
	
	/**
	 * ƷŵĹ
	 * @return
	 */
	private static SendRule getSendRule() {
		  // TODO Auto-generated method stub
		  SendRule s=new SendRule();
		  //ȯѽ
		  s.setMinCost("100");
		  return s;
		}
	
	/**
	 * Ԥ
	 * @return
	 */
	private static   BudgetInfo getBudgetInfo(){
		//Ԥ
		BudgetInfo budgetInfo = new BudgetInfo();
		//Ԥ
		budgetInfo.setBudgetType("QUANTITY"); 
		//Ԥ
		budgetInfo.setBudgetTotal("10258");
		return budgetInfo;
	}
}
